> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Create a WarehouseCredential

POST https://{tenant_name}.benchling.com/api/v3/warehouse-credential:create-warehouse-credential
Content-Type: application/json

Create a new WarehouseCredential. Generates a username and password, provisions the credential in the warehouse, and returns the one-time password.

Reference: https://docs.benchling.com/docs/api/benchling-api/warehouse-credential/createwarehousecredential

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Headers

- `EARLY-ACCESS` (string, optional) — Set to true to access beta operations via /api/v3.

### Body (application/json)

This endpoint expects an object.

- `expiresAt` (datetime, required) — The time after which new connections using the username/password will not be permitted. Upon expiration, currently open connections are not terminated. Must be no more than the tenant's configured maximum (24 hours by default) in the future.
- `label` (string, optional, nullable) — An optional label defined by the user who created the WarehouseCredential.

## Response

### 200

OK

- `password` (string, optional) — The generated password for the warehouse credential. This value is only returned once at creation time and cannot be retrieved again.
- `warehouseCredential` (WarehouseCredentialRef, optional) — The created WarehouseCredential.

## Errors

### 400 Warehouse Credential Create Warehouse Credential Request Bad Request Error

Bad Request

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 403 Warehouse Credential Create Warehouse Credential Request Forbidden Error

Forbidden

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 404 Warehouse Credential Create Warehouse Credential Request Not Found Error

Not Found

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 409 Warehouse Credential Create Warehouse Credential Request Conflict Error

Conflict

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 429 Warehouse Credential Create Warehouse Credential Request Too Many Requests Error

Too Many Requests

- `detail` (TooManyRequestsErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 500 Warehouse Credential Create Warehouse Credential Request Internal Server Error

Internal Server Error

- `detail` (InternalServerErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `errorId` (string, optional)

## Types

### WarehouseCredentialRef

- `__typename` (string, optional)
- `id` (string, optional)

### GeneralErrorDetail

### TooManyRequestsErrorBodyDetail

### InternalServerErrorBodyDetail

## Examples

**Request**

```json
{
  "expiresAt": "2024-01-15T09:30:00Z"
}
```

**Response**

```json
{
  "password": "password",
  "warehouseCredential": {
    "__typename": "__typename",
    "id": "id"
  }
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v3/warehouse-credential:create-warehouse-credential"

payload = { "expiresAt": "2024-01-15T09:30:00Z" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v3/warehouse-credential:create-warehouse-credential';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"expiresAt":"2024-01-15T09:30:00Z"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```